-- Settings
combustionConfig = {}
combustionConfig.font = "Fonts\\FRIZQT__.TTF"
combustionConfig.fontSize = 12
combustionConfig.combatHide = false
local turnYellowDps = 6000
local turnGreenDps = 9000

local CombustionId = 83853
local IgniteId = 12654
local igniteLocalized, combatHidden

local combustion = {}

function GetCombustionTotal()
	return (select(15, UnitDebuff("target", igniteLocalized, nil, "PLAYER")) or 0)/2
end

function combustion.OnUpdate()
	local amount = GetCombustionTotal()
	if combustionConfig.combatHide and amount == 0 and not UnitAffectingCombat("player") then
		combustion.frame:Hide()
		combatHidden = true
	else
		if amount < 1000 then
			combustion.FontString:SetText(floor(amount + 0.5))
		else
			combustion.FontString:SetText(string.format("%.1f", math.floor(amount/100 + 0.5) / 10) .. "k")
		end
		if amount >= turnGreenDps then
			combustion.FontString:SetFont(combustionConfig.font, combustionConfig.fontSize, "THICKOUTLINE")
			combustion.FontString:SetTextColor(0,1,0)
		elseif amount >= turnYellowDps then
			combustion.FontString:SetFont(combustionConfig.font, combustionConfig.fontSize)
			combustion.FontString:SetTextColor(1,1,0)
		else
			combustion.FontString:SetFont(combustionConfig.font, combustionConfig.fontSize)
			combustion.FontString:SetTextColor(1,0,0)
		end
	end
end

function combustion.OnEvent(frame, event, ...)
	if event == "PLAYER_REGEN_DISABLED" and combatHidden then
		combustion.frame:Show()
		combatHidden = false
	elseif event == "VARIABLES_LOADED" then
		combustion.frame:SetWidth(5 * combustionConfig.fontSize)
	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
		if GetSpecialization() == 2 then
			igniteLocalized = GetSpellInfo(IgniteId)
			combustion.frame:Show()
			combustion.frame:SetScript("OnUpdate", combustion.OnUpdate)
			combustion.frame:RegisterEvent("MODIFIER_STATE_CHANGED")
			combustion.frame:RegisterEvent("PLAYER_REGEN_DISABLED")
		else
			combustion.frame:Hide()
			combatHidden = false
			combustion.frame:SetScript("OnUpdate", nil)
			combustion.frame:UnregisterEvent("MODIFIER_STATE_CHANGED")
			combustion.frame:UnregisterEvent("PLAYER_REGEN_DISABLED")
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		combustion.frame:UnregisterEvent("PLAYER_ENTERING_WORLD")
		if select(2,UnitClass("player")) ~= "MAGE" then
			combustion.frame:Hide()
			combustion.frame:SetScript("OnUpdate", nil)
			combustion.frame:SetScript("OnEvent", nil)
			combustion.frame:UnregisterEvent("MODIFIER_STATE_CHANGED")
			combustion.frame:UnregisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
			combustion.frame:UnregisterEvent("VARIABLES_LOADED")
			combustion.frame:UnregisterEvent("PLAYER_REGEN_DISABLED")
		else
			if GetSpecialization() == 2 then
				igniteLocalized = GetSpellInfo(IgniteId)
				combustion.frame:Show()
				combustion.frame:SetScript("OnUpdate", combustion.OnUpdate)
				combustion.frame:RegisterEvent("MODIFIER_STATE_CHANGED")
				combustion.frame:RegisterEvent("PLAYER_REGEN_DISABLED")
			else
				combustion.frame:Hide()
				combatHidden = false
				combustion.frame:SetScript("OnUpdate", nil)
				combustion.frame:UnregisterEvent("MODIFIER_STATE_CHANGED")
				combustion.frame:UnregisterEvent("PLAYER_REGEN_DISABLED")
			end
		end
	elseif event == "MODIFIER_STATE_CHANGED" and combustion.frame:IsShown() then
		local key, state = ...
		if key == "LCTRL" or key == "RCTRL" then
			if state == 1 then
				combustion.frame:EnableMouse(true)
			else
				combustion.frame:EnableMouse(false)
				combustion.frame:StopMovingOrSizing()
			end
		end
	end
end

-- UI Setup
combustion.frame = CreateFrame("Frame", "combFrame", UIParent)
combustion.frame:SetFrameStrata("DIALOG")
combustion.frame:SetWidth(5 * combustionConfig.fontSize)
combustion.frame:SetHeight(24)

combustion.frame:SetPoint("CENTER")
combustion.frame:SetMovable(true)
combustion.frame:RegisterForDrag("LeftButton")
combustion.frame:SetScript("OnDragStart", function(self) self:StartMoving() end)
combustion.frame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)

combustion.frame:SetScript("OnEvent", combustion.OnEvent)
combustion.frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
combustion.frame:RegisterEvent("MODIFIER_STATE_CHANGED")
combustion.frame:RegisterEvent("VARIABLES_LOADED")
combustion.frame:RegisterEvent("PLAYER_ENTERING_WORLD")
combustion.frame:RegisterEvent("PLAYER_REGEN_DISABLED")

combustion.FontString = combustion.frame:CreateFontString("CFontString")
combustion.FontString:SetFont(combustionConfig.font, combustionConfig.fontSize)
combustion.FontString:SetPoint("CENTER", combustion.frame, "CENTER")
combustion.FontString:SetText("0")
combustion.FontString:SetTextColor(1,0,0)

SLASH_Combustion1, SLASH_Combustion2 = "/combustion", "/comb"
SlashCmdList["Combustion"] = function(arg)
	if arg == "combat" then
		combustionConfig.combatHide = not combustionConfig.combatHide
		if not combustionConfig.combatHide then combustion.frame:Show() end
	elseif arg == "reset" then
		combustion.frame:SetPoint("CENTER")
		combustionConfig.font = "Fonts\\FRIZQT__.TTF"
		combustionConfig.fontSize = 12
		combustion.frame:SetWidth(5 * combustionConfig.fontSize)
	else
		arg = tonumber(arg)
		if arg then
			combustionConfig.fontSize = arg
			combustion.frame:SetWidth(5 * combustionConfig.fontSize)
		end
	end
end
